<template>
  <div v-if="user">
    <div class="profile">
      <div class="profile-user">
        <div class="profile-avatar">
          <Avatar :user="user" :size="100" />
        </div>
        <div>
          <div class="profile-username">
            <template v-if="user.display_name">
              {{ user.display_name }}
            </template>
            <template v-else>
              {{ user.username }}
            </template>
          </div>
          <div class="profile-information">
            <div v-if="user.slogan">
              <svg-icon name="rupor" />
              <span>{{ user.slogan }}</span>
            </div>
            <div v-if="user.location">
              <svg-icon name="marker" />
              <span>{{
                [user.location.city, user.location.country]
                  .filter(e => !!e)
                  .join(', ')
              }}</span>
            </div>
          </div>
        </div>
      </div>
      <div v-if="user.bio" class="profile-about">
        {{ user.bio }}
      </div>
      <div class="profile-panel">
        <div class="setting">
          <template v-if="currentUser && currentUser.id == user.id">
            <Button :to="localePath('/profile/settings')">
              {{ $t('buttons.edit_settings') }}
            </Button>
          </template>
          <template v-else-if="currentUser">
            <Button @click="modals.events = !modals.events">
              {{ $t('buttons.photo_session') }}
              <svg-icon name="arrow-line" class="icon-radius" />
            </Button>
          </template>
          <template v-else>
            <Button :to="localePath('/auth/login')">
              {{ $t('buttons.photo_session') }}
              <svg-icon name="arrow-line" class="icon-radius" />
            </Button>
          </template>
        </div>
        <div
          v-if="currentUser && currentUser.id == user.id && type !== 'public'"
        >
          <Button
            size="small"
            variant="primary"
            target="_blank"
            style="height: 100%"
            :to="localePath(`/users/${user.username}`)"
          >
            <svg-icon style="margin: 0" name="external-link" />
          </Button>
        </div>
        <div class="reviews profile-tab">
          <div class="profile-tab__top">0%</div>
          <div class="profile-tab__bottom">Good reviews</div>
        </div>
        <div class="likes profile-tab likes">
          <div class="profile-tab__top">
            {{ user.in_favorites_aggregate.aggregate.count }}
          </div>
          <div class="profile-tab__bottom">Likes</div>
        </div>
        <div v-if="currentUser && currentUser.id !== user.id" class="favorite">
          <Button icon variant="none" size="inline">
            <svg-icon name="like" />
          </Button>
        </div>
        <div>
          <Button
            icon
            variant="none"
            size="inline"
            @click="modals.share = !modals.share"
          >
            <svg-icon name="share" />
          </Button>
        </div>
      </div>
    </div>

    <el-tabs v-model="currentTab" @tab-click="handleTabClick" type="classic">
      <el-tab-pane v-if="media.length" :label="$t('pagenav.feed')" name="feed">
        <Feed :data="media" variant="large" :counter="false" />
        <div v-if="!checkMore" style="margin-top: 25px; text-align: center">
          <Button @click="loadMore" size="inline">Load More</Button>
        </div>
      </el-tab-pane>
      <el-tab-pane
        v-if="albums.length"
        :label="$t('pagenav.albums')"
        name="albums"
      >
        <CardsRow v-loading="albumsLoading">
          <Cards
            v-for="(item, itemKey) in albums"
            :key="itemKey"
            :content="item"
            :path="
              type == 'public' ? '/album/' : '/profile/photography/albums/'
            "
          />
        </CardsRow>
      </el-tab-pane>
      <el-tab-pane
        v-if="user.location"
        :label="$t('pagenav.location')"
        name="location"
      >
        <Map
          v-if="currentTab == 'location'"
          :type="type"
          :data="user.location"
        />
      </el-tab-pane>
      <el-tab-pane
        v-if="user.payment_types && user.payment_types.length"
        :label="$t('pagenav.payment')"
        name="payment"
      >
        <div class="payment__row">
          <div
            v-for="item in user.payment_types"
            :key="item.id"
            class="payment__item"
          >
            <div class="payment__item_top">
              <div class="payment__item_title">
                {{ useTranslate(item.payment_type) }}
              </div>
              <div class="payment__item_price">
                <svg-icon v-if="item.price == 0" name="checked" />
                <template v-else>{{ item.price }} $</template>
              </div>
            </div>
            <div class="payment__item_descr">
              {{ useTranslate('INFO_' + item.payment_type) }}
            </div>
          </div>
        </div>
      </el-tab-pane>
    </el-tabs>

    <portal to="modal">
      <Modal v-model="modals.share">
        <template slot="title">{{ $t('share_link') }}</template>
        <ShareModal :url="`users/${user.id}`" />
      </Modal>
      <Modal v-model="modals.events">
        <template slot="title">New session</template>
        <AddEvent type="session" :clientId="user.id" />
      </Modal>
    </portal>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
  useContext,
  onMounted,
  computed
} from '@nuxtjs/composition-api'

import {
  useAlbumsSubscription,
  useGetMediaQuery,
  useMediaSubscription
} from '~/sdk/hooks'
import { AlbumFragment, MediaFileFragment } from '~/sdk/types'
import useTranslate from '~/hooks/get-translate'

import elInput from '@/components/element/Input.vue'
import elTabs from '@/components/element/Tabs.vue'

import Button from '@/components/ui/Button.vue'
import Avatar from '@/components/ui/Avatar.vue'
import Modal from '@/components/ui/Modal.vue'

import Feed from '@/components/ui/Feed.vue'
import Map from '@/components/ui/Map.vue'
import Cards from '@/components/ui/Cards.vue'
import CardsRow from '@/components/ui/CardsRow.vue'

import ShareModal from '@/components/modal/ShareModal.vue'
import AddEvent from '@/components/modal/AddEvent.vue'

// @ts-ignore TODO
import CoolLightBox from 'vue-cool-lightbox'
import '@/assets/scss/vue-cool-lightbox.scss'

export default defineComponent<{
  user: any | null
  type: string | ''
}>({
  layout: 'events',
  name: 'UserPage',
  props: ['user', 'type'],
  components: {
    Modal,
    AddEvent,
    Button,
    Avatar,
    CoolLightBox,
    Feed,
    Cards,
    CardsRow,
    elInput,
    elTabs,
    ShareModal,
    Map
  },
  setup(props, { root }) {
    const { route } = useContext()
    const currentUser = computed(() => root.$accessor.auth.user)
    const userId = props.user?.id
    // feed

    const totalMedia = ref({
      all: 0,
      offset: 0,
      counter: 0,
      per_page: 8
    })
    const media = ref<MediaFileFragment[]>([])
    const { onResult: mediaResult, loading: mediaLoading } = useGetMediaQuery(
      computed(() => ({
        where: {
          album_id: { _is_null: true },
          event_id: { _is_null: true },
          user_id: { _eq: userId }
        },
        limit: totalMedia.value.per_page,
        offset: totalMedia.value.offset
      }))
    )

    mediaResult(result => {
      if (result?.data?.media_files) {
        media.value.push(...result.data.media_files)
        // media.value = result.data.media_files
        totalMedia.value.all = result.data.count?.aggregate?.count as any
        totalMedia.value.counter = media.value.length
        //totalMedia.value.count = result.data.media_files.length as number
      }
    })
    const checkMore = computed(() => {
      return totalMedia.value.counter == totalMedia.value.all
    })
    const loadMore = () => {
      totalMedia.value.offset = +totalMedia.value.counter
    }

    // albums
    const {
      onResult: albumsResult,
      loading: albumsLoading
    } = useAlbumsSubscription({
      userId: userId,
      limit: 20000,
      offset: 0
    })
    const albums = ref<AlbumFragment[]>([])
    albumsResult(result => {
      if (result?.data?.albums) {
        albums.value = result.data.albums
      }
    })

    const modals = ref({
      events: false,
      share: false
    })

    onMounted(() => {
      initTab()
    })

    // tabs
    const defaultTab = 'feed'
    let currentTab = ref('')
    const initTab = () => {
      let initialTab =
        route.value.hash !== '' ? route.value.hash.substr(1) : defaultTab
      currentTab.value = initialTab
    }
    const handleTabClick = (tab: any) => {
      location.hash = tab.name
    }

    return {
      useTranslate,
      currentUser,

      media,
      mediaLoading,

      albums,
      albumsLoading,

      currentTab,
      handleTabClick,
      modals,
      checkMore,
      loadMore,
      totalMedia
    }
  }
})
</script>

<style lang="scss" scoped>
.search-map {
  height: 500px;
  overflow: hidden;
  position: relative;
}
.profile {
  @media (min-width: 991.98px) {
    display: inline-flex;
    flex-direction: column;
  }
  &-user {
    margin-bottom: 25px;
    font-size: 0px;
    @media (min-width: 991.98px) {
      margin-bottom: 50px;
      display: flex;
      align-items: center;
    }
  }
  &-avatar {
    flex: none;
    text-align: center;
    margin-bottom: 10px;
    @media (min-width: 991.98px) {
      margin-right: 50px;
      margin-bottom: 0px;
    }
  }

  &-username {
    font-weight: 300;
    color: #ffffff;
    margin-bottom: 15px;
    text-align: center;
    font-size: 35px;
    line-height: 40px;
    letter-spacing: -0.08px;
    @media (min-width: 991.98px) {
      margin-bottom: 10px;
      font-size: 55px;
      line-height: 60px;
      letter-spacing: -1.38px;
      text-align: left;
    }
  }

  &-about {
    font-size: 22px;
    line-height: 28px;
    letter-spacing: 0px;
    color: #ffffff;
    margin-bottom: 25px;
    @media (min-width: 991.98px) {
      max-width: 70%;
      margin-bottom: 50px;
      font-size: 30px;
      line-height: 34px;
    }
  }

  &-information {
    display: flex;
    flex-direction: column;
    @media (min-width: 991.98px) {
      margin-right: -30px;
      align-items: center;
      flex-direction: row;
    }
    > div {
      display: flex;
      align-items: center;
      padding-right: 30px;
      @media (max-width: 991.98px) {
        padding-right: 0px;
        padding-bottom: 10px;
        &:last-child {
          padding-bottom: 0px;
        }
      }
      svg {
        flex: none;
        fill: #0065ff;
        width: 20px;
        height: 20px;
        margin-right: 15px;
      }
      span {
        font-size: 20px;
        line-height: 26px;
        letter-spacing: 0px;
        color: #8591ad;
        @media (min-width: 991.98px) {
          font-size: 24px;
          line-height: 28px;
        }
      }
    }
  }

  &-panel {
    margin-bottom: 20px;
    font-size: 0px;
    display: grid;
    grid-column-gap: 15px;
    grid-row-gap: 15px;
    grid-template-areas: 'setting setting' 'reviews favorite' 'likes share';
    grid-template-columns: 1fr 65px;

    ::v-deep .btn[icon] {
      border-radius: 10px;
      background: #272c3b;
      @media (max-width: 991.98px) {
        padding: 10px;
        width: 100%;
        border-radius: 3px;
        svg {
          width: 20px;
          height: 20px;
        }
      }
    }

    @media (min-width: 991.98px) {
      margin-bottom: 70px;
      justify-content: flex-start;
      grid-template-areas: 'setting reviews likes favorite share';
      grid-template-columns: auto;
      grid-column-gap: 25px;
      ::v-deep .btn[icon] {
        border-radius: 50%;
      }
    }
    .setting {
      grid-area: setting;
      @media (max-width: 991.98px) {
        ::v-deep .btn {
          display: flex;
        }
      }
    }
    .reviews {
      grid-area: reviews;
    }
    .likes {
      grid-area: likes;
    }
    .favorite {
      grid-area: favorite;
    }
  }

  &-tab {
    border: 1px solid #0065ff;
    border-radius: 3px;
    padding: 10px 15px;
    @media (min-width: 991.98px) {
      border-radius: 10px;
      padding: 10px 30px 10px 20px;
    }
    &.likes {
      border: 1px solid #474e65;
    }
    &__top {
      font-weight: bold;
      font-size: 20px;
      line-height: 20px;
      color: #ffffff;
      margin-bottom: 3px;
      @media (min-width: 991.98px) {
        font-size: 30px;
        line-height: 30px;
      }
    }
    &__bottom {
      font-size: 16px;
      line-height: 16px;
      color: #8591ad;
      @media (min-width: 991.98px) {
        font-size: 20px;
        line-height: 20px;
      }
    }
  }
}

.payment {
  &__row {
    display: grid;
    grid-template-columns: repeat(12, 1fr);
    grid-gap: 20px;
    font-size: 0px;
    @media (min-width: 1199.98px) {
      grid-gap: 35px;
    }
  }
  &__item {
    grid-column: span 6;
    background: #3b435a;
    border-radius: 13px;
    padding: 35px 30px 50px 30px;
    text-align: center;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    @media (min-width: 1199.98px) {
      grid-column: span 3;
    }
    &_top {
      flex: 1;
      padding-bottom: 35px;
      margin-bottom: 20px;
      border-bottom: 2px solid #7683ad;
    }

    &_title {
      font-weight: bold;
      font-size: 18px;
      line-height: 23px;
      letter-spacing: 0.9px;
      color: #00ffb3;
      text-transform: uppercase;
      margin-bottom: 10px;
    }
    &_price {
      font-weight: 500;
      font-size: 45px;
      line-height: 56px;
      letter-spacing: 0px;
      color: #ffffff;
      display: flex;
      align-items: center;
      justify-content: center;

      svg {
        margin: 10px 0px;
        width: 50px;
        height: 40px;
        fill: #00ffb3;
      }
    }
    &_descr {
      flex: 1;
      font-size: 24px;
      line-height: 30px;
      color: #ffffff;
      padding: 0 10px;
    }
  }
}
</style>
